import os
import re
import string
import sys

try:
  from mod_python import apache
  from mod_python import util
except:
  from localmod_python import apache
  from localmod_python import util

import Numeric
import matplotlib
matplotlib.use('GD')
#os.environ['GDFONTPATH'] = '/sw/share/matplotlib/'
from matplotlib.backends.backend_gd import Figure, show
#from matplotlib.matlab import *
from matplotlib.axes import Subplot

from simpletal import simpleTAL, simpleTALES, simpleTALUtils
talCache = simpleTALUtils.TemplateCache()

_q_export = ['handler', 'default', 'graph', 'weightplot', 'weight', 'scat']

def setXHTMLtype(req):
  if 'application/xhtml+xml' in req.headers_in['Accept']:
    req.content_type = 'application/xhtml+xml'
  else:
    req.content_type = 'text/html'
  
def handler(req):
  base, object = os.path.split(req.uri)
  
  if object in _q_export:
    object = globals()[object]
    if callable(object):
      #return util.apply_fs_data(object, req.form, req=req)
      _kargs = {'req': req}
      req.form = util.FieldStorage(req, keep_blank_values=1)
      _kargs.update(req.form)
      return apply(object, [], _kargs)
    else:
      return apache.HTTP_NOT_FOUND
  else:
    try:
      req.sendfile(req.filename)
      return apache.OK
    except IOError:
      return apache.HTTP_NOT_FOUND

def makePlot(last, width, height, decay=0.4):
  """Make a plot"""
  
  labels, data, averages = getData(last=last, decay=decay)
  xrange = range(len(labels))
  
  dpi = 100
  figsize = (width/dpi, height/dpi) # put fig size in data coords
  f = Figure(figsize, dpi)
  a = Subplot(f, 1,1,1)
  a.grid(1)
  f.add_axis(a)

  print a
  print dir(a)
  p = a.scatter(xrange, data, s=[.3]*len(xrange))
  l = a.plot(xrange, averages,'k:')
  #
  a.set_title("title")
  a.set_xlabel('x range')
  a.set_ylabel('y range')
  type = 'svg'

  # make a square plot
  x1, x2 = a.get_xlim()
  y1, y2 = a.get_ylim()
  a.set_ylim([y2-(x2-x1), y2])

  # make the imagemap
  yFigSize = f.bbox.y.max()

  s = ['<map id="graph" >']
  for i in range(len(p)):
    point = p[i]
    rect_xmin = point.get_window_extent().x.min()
    rect_xmax = point.get_window_extent().x.max()
    rect_ymin = yFigSize - point.get_window_extent().y.min()
    rect_ymax = yFigSize - point.get_window_extent().y.max()
    area = '<area alt="graph" shape="rect" coords="%s,%s,%s,%s" href="thing" title="%s" />'
    area %= (int(rect_xmin), int(rect_ymax), int(rect_xmax), int(rect_ymin), labels[i])
    s += [area]
  s += ['</map>']

  # save the image for later transmission
  type = 'svg'
  f.print_figure('/tmp/example1.'+type, dpi)
  show()
  return string.join(s, os.linesep)

if __name__ == "__main__":
  mode = 'thread'
  from localmod_python import server
  print "starting localmod_python"
  if mode == 'single':
    server.run(handler)
  else:
    import webbrowser
    if mode == 'threading':
      import threading
      class s(threading.Thread):
        def __init__(self, group=None, target=None, name=None, args=(), kwargs={}):
          self.handler = args[0]
        def run():
          server.run(self.handler)
      sThread = s(args=(handler,))
      sThread.setDaemon(1)
      sThread.start()
    elif mode == 'thread':
      import thread
      thread.start_new_thread(server.run, (handler,))
    else:
      raise "unrecognized threading model"

    from IPython.Shell import IPythonShellEmbed
    #webbrowser.open("http://127.0.0.1:8001/graph", 1)
    ipshell = IPythonShellEmbed()
    ipshell()
      
    
  

